if not CompactHUD then return end

local hook_files = {
    ["lib/managers/hud/hudteammate"] = "lib/managers/hud/hudteammate.lua",
    ["lib/managers/hud/hudtemp"] = "lib/managers/hud/hudtemp.lua"
}

local CompactHUD_Colors = {}

if CompactHUD.setup then

	CompactHUD.extra_colors = {
		{color = Color(165/255, 42/255, 42/255), menu_name = "Brown"},
		{color = Color(255/255, 127/255, 80/255), menu_name = "Coral"},
		{color = Color(220/255, 20/255, 60/255), menu_name = "Crimson"},
		{color = Color(0, 25/2555, 255/255), menu_name = "Cyan"},
		{color = Color(255/255, 0, 255/255), menu_name = "Fuchsia"},
		{color = Color(255/255, 215/255, 0), menu_name = "Gold"},
		{color = Color(128/255, 128/255, 128/255), menu_name = "Grey"},
		{color = Color(230/255, 230/255, 250/255), menu_name = "Lavender"},
		{color = Color(128/255, 0, 0), menu_name = "Maroon"},
		{color = Color(0, 0, 128/255), menu_name = "Navy"},
		{color = Color(128/255, 128/255, 0), menu_name = "Olive"},
		{color = Color(250/255, 128/255, 114/255), menu_name = "Salmon"},
		{color = Color(192/255, 192/255, 192/255), menu_name = "Silver"},
		{color = Color(210/255, 180/255, 140/255), menu_name = "Tan"},
		{color = Color(0, 128/255, 128/255), menu_name = "Teal"},
		{color = Color(64/255, 224/255, 208/255), menu_name = "Turquoise"},
		{color = Color(245/255, 222/255, 179/255), menu_name = "Wheat"}
	}
	
	for k, v in pairs( CompactHUD.extra_colors ) do
	  	table.insert( CompactHUD.colors , v )
  	end
	
	for k, v in pairs( CompactHUD.colors ) do
	  	table.insert( CompactHUD_Colors , "CompactHUDcolor" .. k )
  	end
	
	for k, v in pairs(CompactHUD.options) do
		if k:match("color") and type(v) == "number" and v > #CompactHUD.extra_colors then
			CompactHUD.options[k] = CompactHUD.options[k] + #CompactHUD.extra_colors	
		end
	end

	if CompactHUD.options.ammo_mag_color == nil then 
		CompactHUD.options.ammo_mag_color = 3
		CompactHUD:Save()
	end
	
	if CompactHUD.options.ammo_total_color == nil then 
		CompactHUD.options.ammo_total_color = 3
		CompactHUD:Save()
	end
	
	CompactHUD.ammo_mag_color = CompactHUD.colors[CompactHUD.options.ammo_mag_color] and CompactHUD.colors[CompactHUD.options.ammo_mag_color].color or Color.white
	CompactHUD.ammo_total_color = CompactHUD.colors[CompactHUD.options.ammo_total_color] and CompactHUD.colors[CompactHUD.options.ammo_total_color].color or Color.white
	
end

Hooks:Add( "LocalizationManagerPostInit" , "CompactHUDExtrasPlugin_loc" , function( self )

	LocalizationManager:add_localized_strings( {
	    ["dynamic_hp_title"] = "Dynamic HP",
	    ["dynamic_hp_desc"] = "Every player's HP is based on their ID colour and turns more red as it lowers.",
		["animated_hp_title"] = "Animated HP",
		["animated_hp_desc"] = "When gaining or losing health, the HP value animates visually!",
	    ["rename_hp_title"] = "Space Out Teammate HP",
	    ["rename_hp_desc"] = "Places a space in between the value and \"HP\". (e.g. \"100HP\" --> \"100 HP\")",
		["remove_divider_title"] = "Remove HP Divider",
		["remove_divider_desc"] = "Removes the \"|\" between the username and HP. (e.g. \"[username] | 100HP\" --> \"[username] 100HP\")",
		["disable_hp_hurt_title"] = "Disable Red HP on Hurt",
		["disable_hp_hurt_desc"] = "Disables the red coloured animation when taking damage on your HP.",
		
		["ammo_mag_color_title"] = "Magazine Color",
		["ammo_mag_color_desc"] = "The color of the magazine value of the main HUD Background.",
		["ammo_total_color_title"] = "Total Ammo Color",
		["ammo_total_color_desc"] = "The color of the total ammo value of the HUD Background.",
		["dynamic_mag_title"] = "Dynamic Magazine",
		["dynamic_mag_desc"] = "Enabling this makes the magazine value turn more red as it decreases.",
		["dynamic_total_title"] = "Dynamic Total Ammo",
		["dynamic_total_desc"] = "Enabling this makes the total ammo value turn more red as it decreases.",
		["animated_total_title"] = "Animated Total Ammo",
		["animated_total_desc"] = "When picking up or gaining ammo, the total ammo count animates visually!",
		
		["detailed_carry_title"] = "Detailed Carry Panel",
		["detailed_carry_desc"] = "The carry panel will display the weight as well as the base cash value.",
  	} )
	
	for k, v in pairs( CompactHUD.colors ) do
		LocalizationManager:add_localized_strings({
			[ "CompactHUDcolor" .. k ] = v.menu_name,
		})
  	end
	
end )

Hooks:Add( "MenuManagerPopulateCustomMenus" , "MenuManagerPopulateCustomMenusCompactHUDExtrasPlugin" , function( menu_manager, nodes )

	MenuCallbackHandler.dynamic_hp_enable = function(self, item)
		CompactHUD.options.dynamic_hp = ( item:value() == "on" and true or nil )
		CompactHUD:Save()
		CompactHUD:UpdateGame()
	end
	
	MenuCallbackHandler.animated_hp_enable = function(self, item)
		CompactHUD.options.animated_hp = ( item:value() == "on" and true or nil )
		CompactHUD:Save()
		CompactHUD:UpdateGame()
	end
	
	MenuCallbackHandler.rename_hp_enable = function(self, item)
		CompactHUD.options.rename_hp = ( item:value() == "on" and true or nil )
		CompactHUD:Save()
		CompactHUD:UpdateGame()
	end
	
	MenuCallbackHandler.remove_divider_enable = function(self, item)
		CompactHUD.options.remove_divider = ( item:value() == "on" and true or nil )
		CompactHUD:Save()
		CompactHUD:UpdateGame()
	end
	
	MenuCallbackHandler.disable_hp_hurt = function(self, item)
		CompactHUD.options.disable_hp_hurt = ( item:value() == "on" and true or nil )
		CompactHUD:Save()
		CompactHUD:UpdateGame()
	end
	
	MenuCallbackHandler.ammo_mag_color = function(self, item)
		CompactHUD.options.ammo_mag_color = item:value()
		CompactHUD.ammo_mag_color = CompactHUD.colors[CompactHUD.options.ammo_mag_color].color
		CompactHUD:Save()
		CompactHUD:UpdateGame()
	end
	
	MenuCallbackHandler.dynamic_mag_enable = function(self, item)
		CompactHUD.options.dynamic_mag = ( item:value() == "on" and true or nil )
		CompactHUD:Save()
		CompactHUD:UpdateGame()
	end
	
	MenuCallbackHandler.ammo_total_color = function(self, item)
		CompactHUD.options.ammo_total_color = item:value()
		CompactHUD.ammo_total_color = CompactHUD.colors[CompactHUD.options.ammo_total_color].color
		CompactHUD:Save()
		CompactHUD:UpdateGame()
	end
	
	MenuCallbackHandler.animated_total_enable = function(self, item)
		CompactHUD.options.animated_total = ( item:value() == "on" and true or nil )
		CompactHUD:Save()
		CompactHUD:UpdateGame()
	end
	
	MenuCallbackHandler.dynamic_total_enable = function(self, item)
		CompactHUD.options.dynamic_total = ( item:value() == "on" and true or nil )
		CompactHUD:Save()
		CompactHUD:UpdateGame()
	end
	
	MenuCallbackHandler.detailed_carry_enable = function(self, item)
		CompactHUD.options.detailed_carry = ( item:value() == "on" and true or nil )
		CompactHUD:Save()
		CompactHUD:UpdateGame()
	end
	
	MenuHelper:AddDivider( {
		id = "CompactHUDExtrasPlugin_Divider1",
		size = 16,
		menu_id = CompactHUD.options_menu,
		priority = 700,
	} )
	
	MenuHelper:AddToggle( {
		id = "dynamic_hp_enable",
		title = "dynamic_hp_title",
		desc = "dynamic_hp_desc",
		callback = "dynamic_hp_enable",
		menu_id = CompactHUD.options_menu,
		value = CompactHUD.options.dynamic_hp,
		priority = 695,
	} )
	
	MenuHelper:AddToggle( {
		id = "animated_hp_enable",
		title = "animated_hp_title",
		desc = "animated_hp_desc",
		callback = "animated_hp_enable",
		menu_id = CompactHUD.options_menu,
		value = CompactHUD.options.animated_hp,
		priority = 690,
	} )
	
	MenuHelper:AddToggle( {
		id = "rename_hp_enable",
		title = "rename_hp_title",
		desc = "rename_hp_desc",
		callback = "rename_hp_enable",
		menu_id = CompactHUD.options_menu,
		value = CompactHUD.options.rename_hp,
		priority = 685,
	} )
	
	MenuHelper:AddToggle( {
		id = "remove_divider_enable",
		title = "remove_divider_title",
		desc = "remove_divider_desc",
		callback = "remove_divider_enable",
		menu_id = CompactHUD.options_menu,
		value = CompactHUD.options.remove_divider,
		priority = 680,
	} )
	
	MenuHelper:AddToggle( {
		id = "disable_hp_hurt",
		title = "disable_hp_hurt_title",
		desc = "disable_hp_hurt_desc",
		callback = "disable_hp_hurt",
		menu_id = CompactHUD.options_menu,
		value = CompactHUD.options.disable_hp_hurt,
		priority = 675,
	} )
	
	MenuHelper:AddDivider( {
		id = "CompactHUDExtrasPlugin_Divider2",
		size = 8,
		menu_id = CompactHUD.options_menu,
		priority = 670,
	} )
	
	MenuHelper:AddMultipleChoice( {
		id = "ammo_mag_color",
		title = "ammo_mag_color_title",
		desc = "ammo_mag_color_desc",
		callback = "ammo_mag_color",
		items = CompactHUD_Colors,
		menu_id = CompactHUD.options_menu,
		value = CompactHUD.options.ammo_mag_color,
		priority = 665,
	} )
	
	MenuHelper:AddToggle( {
		id = "dynamic_mag_enable",
		title = "dynamic_mag_title",
		desc = "dynamic_mag_desc",
		callback = "dynamic_mag_enable",
		menu_id = CompactHUD.options_menu,
		value = CompactHUD.options.dynamic_mag,
		priority = 660,
	} )
	
	MenuHelper:AddDivider( {
		id = "CompactHUDExtrasPlugin_Divider3",
		size = 4,
		menu_id = CompactHUD.options_menu,
		priority = 655,
	} )
	
	MenuHelper:AddMultipleChoice( {
		id = "ammo_totsl_color",
		title = "ammo_total_color_title",
		desc = "ammo_total_color_desc",
		callback = "ammo_total_color",
		items = CompactHUD_Colors,
		menu_id = CompactHUD.options_menu,
		value = CompactHUD.options.ammo_total_color,
		priority = 650,
	} )
	
	MenuHelper:AddToggle( {
		id = "animated_total_enable",
		title = "animated_total_title",
		desc = "animated_total_desc",
		callback = "animated_total_enable",
		menu_id = CompactHUD.options_menu,
		value = CompactHUD.options.animated_total,
		priority = 645,
	} )
	
	MenuHelper:AddToggle( {
		id = "dynamic_total_enable",
		title = "dynamic_total_title",
		desc = "dynamic_total_desc",
		callback = "dynamic_total_enable",
		menu_id = CompactHUD.options_menu,
		value = CompactHUD.options.dynamic_total,
		priority = 640,
	} )
	
	MenuHelper:AddDivider( {
		id = "CompactHUDExtrasPlugin_Divider4",
		size = 4,
		menu_id = CompactHUD.options_menu,
		priority = 635,
	} )
	
	MenuHelper:AddToggle( {
		id = "detailed_carry_enable",
		title = "detailed_carry_title",
		desc = "detailed_carry_desc",
		callback = "detailed_carry_enable",
		menu_id = CompactHUD.options_menu,
		value = CompactHUD.options.detailed_carry,
		priority = 630,
	} )
	
end )

if RequiredScript then
	local requiredScript = RequiredScript:lower()
	if hook_files[ requiredScript ] then
		dofile( ModPath .. hook_files[ requiredScript ] )
	end
end