function HUDTeammate:set_health_color( hp )
	return ( self._panel:child( "callsign" ):color() * ( math.round( hp ) / 100 ) + Color.red * ( 1 - math.round( hp ) / 100 ) )
end

Hooks:PostHook( HUDTeammate , "UpdateSettings" , "CompactHUDPostUpdateSettings" , function( self )
	
	if self._player_panel:child("hp_text") and CompactHUD.options.dynamic_hp then
	
		DelayedCalls:Add( "CompactHUDChangeHPColour" , 60 , function()
			self._player_panel:child("hp_text"):set_color( self:set_health_color( math.floor( self._lastvalue or 100 ) ) )
			DelayedCalls:Remove( "CompactHUDChangeHPColour" )
		end )
		
	end
	
	if not self._main_player then
		self._player_panel:child("hp_text"):set_text( ( CompactHUD.options.remove_divider and "" or "| " ) .. math.floor( self._lastvalue or 100 ) .. ( CompactHUD.options.rename_hp and " HP" or "HP" ) )
	end
	
	if not CompactHUD.options.dynamic_mag then
		self._player_panel:child("weapons_panel"):child("primary_weapon_panel"):child("ammo_clip"):set_color( CompactHUD.ammo_mag_color )
		self._player_panel:child("weapons_panel"):child("secondary_weapon_panel"):child("ammo_clip"):set_color( CompactHUD.ammo_mag_color )
	end
	
	if not CompactHUD.options.dynamic_total then
		self._player_panel:child("weapons_panel"):child("primary_weapon_panel"):child("ammo_total"):set_color( CompactHUD.ammo_total_color )
		self._player_panel:child("weapons_panel"):child("secondary_weapon_panel"):child("ammo_total"):set_color( CompactHUD.ammo_total_color )
	end
	
end )

Hooks:PostHook( HUDTeammate , "init" , "CompactHUDPostInit" , function( self , i , teammates_panel , is_player , width )

	if self._player_panel:child("hp_text") and CompactHUD.options.dynamic_hp then
		self._player_panel:child("hp_text"):set_color( self._panel:child("callsign"):color() or Color.white )
	end
	
	if not self._main_player then
		self._player_panel:child("hp_text"):set_text( ( CompactHUD.options.remove_divider and "" or "| " ) .. "100" .. ( CompactHUD.options.rename_hp and " HP" or "HP" ) )
	end

end )

Hooks:PostHook( HUDTeammate , "set_ammo_amount_by_type" , "CompactHUDPostSetAmmoAmountByType" , function( self , type , max_clip , current_clip , current_left , max )

	local weapon_panel = self._player_panel:child("weapons_panel"):child(type .. "_weapon_panel")
	
	local ammo_clip = weapon_panel:child("ammo_clip")
	local clip = current_clip / max_clip * 100
	
	if CompactHUD.options.dynamic_mag then
		ammo_clip:set_color( CompactHUD.ammo_mag_color * ( math.floor( clip ) / 100 ) + Color(1, 0.9, 0.3, 0.3) * ( 1 - math.floor( clip ) / 100 ) )
	else
		ammo_clip:set_color( CompactHUD.ammo_mag_color )
	end
	
	local ammo_total = weapon_panel:child("ammo_total")
	local total = current_left / max * 100
	
	if CompactHUD.options.dynamic_total then
		ammo_total:set_color( CompactHUD.ammo_total_color * ( math.floor( total ) / 100 ) + Color(1, 0.9, 0.3, 0.3) * ( 1 - math.floor( total ) / 100 ) )
	else
		ammo_total:set_color( CompactHUD.ammo_total_color )
	end
	
	if CompactHUD.options.animated_total and self._ammo_lastvalue and self._ammo_lastvalue[type] and current_left > self._ammo_lastvalue[type] then
		ammo_total:animate(callback(self, self, "ammo_up"), self._lastvalue, current_left, type, current_clip, max)
	end
	
	if not self._ammo_lastvalue then
		self._ammo_lastvalue = {}
		self._ammo_lastvalue[type] = current_left
	end
	
	self._ammo_lastvalue[type] = current_left

end )

Hooks:PreHook( HUDTeammate , "set_health" , "CompactHUDPreSetHealth" , function( self , data )

	self._anim_lastvalue = self._lastvalue

end )

Hooks:PostHook( HUDTeammate , "set_health" , "CompactHUDPostSetHealth" , function( self , data )
	
	local hp = data.current / data.total * 100
	
	if self._player_panel:child("hp_text") and CompactHUD.options.dynamic_hp then
		self._player_panel:child("hp_text"):set_color( self:set_health_color( math.floor( hp ) ) )
	end
	
	if CompactHUD.options.animated_hp then
	
		if self._anim_lastvalue and math.floor(self._anim_lastvalue) ~= math.floor(hp) then
		
			if math.floor(hp) - math.floor(self._anim_lastvalue) > 0 then
				self._player_panel:child("hp_text"):animate(callback(self, self, "health_change"), self._anim_lastvalue, hp, true)
			else
				self._player_panel:child("hp_text"):animate(callback(self, self, "health_change"), self._anim_lastvalue, hp, false)
			end
			
		end
		
	end
	
	if not self._main_player then
		self._player_panel:child("hp_text"):set_text( ( CompactHUD.options.remove_divider and "" or "| " ) .. math.floor( hp ) .. ( CompactHUD.options.rename_hp and " HP" or "HP" ) )
	end

end )

function HUDTeammate:ammo_up( ammo_panel , lastvalue , value , type , current_clip , max )

	local t = 0
	local Ammo_size = 24
	while t < 1 do
		t = t + coroutine.yield()
		local n = 1 - math.sin((t / 2) * 180)
		ammo = math.clamp(lastvalue + (t * ((value / max) * 100)), lastvalue, CompactHUD.options.true_ammototal and value - current_clip or value)
		ammo_panel:set_font_size(math.lerp(Ammo_size + 1, Ammo_size + 4, n))
		ammo_panel:set_text(tostring(math.floor(ammo)))
	end
	ammo_panel:set_font_size(Ammo_size)
	
	if CompactHUD.options.true_ammototal then
		ammo_total:set_text(tostring(self._ammo_lastvalue[type]) - tostring(current_clip))
	else
		ammo_total:set_text(tostring(self._ammo_lastvalue[type]))
	end

end

function HUDTeammate:health_hurt( hp_text )

	if CompactHUD.options.disable_hp_hurt then
		return
	end
	
	local t = 0
	while t < 0.5 do
		t = t + coroutine.yield()
		local n = 1 - math.sin(t / 720)
		hp_text:set_color(Color(
			hp_text:color().r + (Color.red.r - hp_text:color().r) * n,
			hp_text:color().g + (Color.red.g - hp_text:color().g) * n,
			hp_text:color().b + (Color.red.b - hp_text:color().b) * n)
		)
	end
	hp_text:set_color( CompactHUD.options.dynamic_hp and self:set_health_color( math.floor( self._lastvalue ) ) or Color.white )

end

function HUDTeammate:health_change( hp_text , lastvalue , value , positive )

	local t = 0
	local Health_size = self._main_player and 32 or tweak_data.hud_players.name_size
	while t < 1 do
		t = t + coroutine.yield()
		local n = 1 - math.sin((t / 2) * 180)
		hp = positive and math.clamp(lastvalue + (t * 10), lastvalue, value) or math.clamp(lastvalue - (t * 10), value, lastvalue)
		if self._main_player then	
			hp_text:set_font_size(math.lerp(Health_size + 1, Health_size + 4, n))
			hp_text:set_text(math.floor(hp))
		else
			hp_text:set_text( ( CompactHUD.options.remove_divider and "" or "| " ) .. math.floor( hp ) .. ( CompactHUD.options.rename_hp and " HP" or "HP" ) )	
		end
	end
	
	hp_text:set_font_size(Health_size)
	if self._main_player then 
		hp_text:set_text(math.floor(value))
	else
		hp_text:set_text( ( CompactHUD.options.remove_divider and "" or "| " ) .. math.floor( value ) .. ( CompactHUD.options.rename_hp and " HP" or "HP" ) )	
	end

end

Hooks:PostHook( HUDTeammate , "set_custom_radial" , "CompactHUDPostSetCustomRadial" , function( self , data )

	if self._player_panel:child("hp_text") and CompactHUD.options.dynamic_hp then
	
		local hp = data.current / data.total * 100
		
		self._player_panel:child("hp_text"):set_color( self:set_health_color( math.floor( hp ) ) )
	
	end

end )